// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

//#include "Car.hpp"  // Define class Car
// Pretend file "Car.hpp" contains the following (this is from FAQ 2.17):

#include <string>
using namespace std;

class Car {
public:
  virtual void startEngine();     // Line 1
  virtual bool isRunning() const; // Line 2
  virtual void tuneRadioTo(const string& band, int freq); // Line 3
protected:
  bool isRunning_;                // Line 4
  bool radioOnAM_;
  int  radioFreq_;
};

void Car::startEngine()
{ isRunning_ = true; }

bool Car::isRunning() const
{ return isRunning_; }

void Car::tuneRadioTo(const string& band, int freq)
{ radioOnAM_ = (band == "AM"); radioFreq_ = freq; }

void f()
{
  Car a;                     // 1: Create an object
  a.startEngine();           // 2: Call a member function
  a.tuneRadioTo("AM", 770);  // 3: Call another member function
}                            // 4: Destroy the object

int main()
{
  f();
}
