// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Car {
public:
  Car();
  ~Car();
  Car(const Car& c);
  static int num();  // Member function to access num_
protected:
  static int num_;   // Declaration of the static data member
};

Car::Car()
{
  ++num_;
}

Car::~Car()
{
  --num_;
}

int Car::num()
{
  return num_;
}

int Car::num_ = 0;  // Definition of the static data member

int main()
{
  cout << "Before creating any cars, num() returns " << Car::num() << "\n";
  Car a, b, c;
  cout << "After creating three cars, num() returns " << Car::num() << "\n";
}
