// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Empty { };
class BadPosition { };

class Stack {
public:
  void     push(int item) throw();   // Push another item onto this
  int      pop() throw(Empty);       // Remove the top item from this
  int      top() const throw(Empty); // Peek at the top item of this
  unsigned size() const throw();     // Returns the number of items
};

class List {
public:
  void     prepend(int item) throw();
  void     append(int item) throw();
  void     removeFirst() throw(Empty);
  void     removeLast() throw(Empty);
  void     insertAtPosition(int item, unsigned position) throw(BadPosition);
  void     removeAtPosition(unsigned position) throw(BadPosition,Empty);
  int&     operator[] (unsigned index)       throw(BadPosition,Empty);
  int      operator[] (unsigned index) const throw(BadPosition,Empty);
  unsigned size() const throw();
  void     setSize(unsigned newSize) throw();
  unsigned countMatches(int itemToMatch) const throw();
  unsigned findPositionOfMatch(int item) const throw();
};
