// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Empty { };
class BadPosition { };

class List {
public:
  void     prepend(int item) throw();
  void     append(int item) throw();
  int      removeFirst() throw(Empty);
  int      removeLast() throw(Empty);
  void     insertAtPosition(int item, unsigned position) throw(BadPosition);
  int      removeAtPosition(unsigned position) throw(BadPosition,Empty);
  int&     operator[] (unsigned index)       throw(BadPosition,Empty);
  int      operator[] (unsigned index) const throw(BadPosition,Empty);
  unsigned size() const throw();
  void     setSize(unsigned newSize) throw();
  unsigned countMatches(int itemToMatch) const throw();
  unsigned findPositionOfMatch(int item) const throw();
protected:
  // Implementation intentionally omitted
};

class Stack {
public:
  void     push(int x)  throw();
  int      pop()        throw(Empty);
  int      top()  const throw(Empty);
  unsigned size() const throw();
protected:
  List list_;
};

void Stack::push(int x) throw()
{ list_.append(x); }

int Stack::pop() throw(Empty)
{ return list_.removeLast(); }

int Stack::top() const throw(Empty)
{ return list_[list_.size()-1]; }

unsigned Stack::size() const throw()
{ return list_.size(); }
