// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <stdexcept>
using namespace std;

class Array {
public:
  float& operator[] (unsigned i) throw(out_of_range);
protected:
  float data_[100];
};

inline float& Array::operator[] (unsigned i) throw(out_of_range)
{
  if (i >= 100u) throw out_of_range("Array index is out of range");
  return data_[i];
}

int main()
{
  Array a;
  for (unsigned i = 0; i < 100; ++i)
    a[i] = 3.14 * i;
  for (unsigned j = 0; j < 100; ++j)
    cout << a[j] << '\n';
}
