// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <memory>
using namespace std;

class Fred;  // Forward declaration
typedef  auto_ptr<Fred>  FredPtr;

class Fred {
public:
  static FredPtr create()              throw();
  static FredPtr create(int i)         throw();
  static FredPtr create(const Fred& x) throw();
  virtual void goBowling();
private:
  Fred(int i=10)      throw();
  Fred(const Fred& x) throw();
  int i_;
};

FredPtr Fred::create()              throw(bad_alloc) { return new Fred();  }
FredPtr Fred::create(int i)         throw(bad_alloc) { return new Fred(i); }
FredPtr Fred::create(const Fred& x) throw(bad_alloc) { return new Fred(x); }
Fred::Fred(int i)         throw() : i_(i)    { }
Fred::Fred(const Fred& x) throw() : i_(x.i_) { }

void sample()
{
  FredPtr p(Fred::create(5));
  p->goBowling();
}
