// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
using namespace std;

class Fred {
public:
  Fred(int i, int j) throw();
  virtual ~Fred() throw();
};

Fred* construct(void* place) throw()
{
  Fred* p = new(place) Fred(42, 42);
  return p;
}

void destruct(Fred* p) throw()
{
  p->~Fred();  // Do this only with placement new
}

void sample() throw()
{
  void* place = (void*) 0xFEEDBABE;
  Fred* p = construct(place);
  // ...
  destruct(p);
}
