// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"


#include <new>
using namespace std;

class Fred {
public:
  Fred() throw();
  virtual ~Fred() throw();
};

void sample() throw(bad_alloc)
{
  // Original code:  Fred* p = new Fred();
  Fred* p = (Fred*) operator new(sizeof(Fred)); // Step 1: allocate memory
  try {
    new(p) Fred();       // Step 2: construct the object; see FAQ 12.14
  }
  catch (...) {
    operator delete(p);  // Deallocate the memory
    throw;               // Re-throw the exception that the constructor threw
  }
}
