// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#ifndef INLINE_HPP
#define INLINE_HPP

#ifdef USE_INLINE
  #define INLINE  inline
#else
  #define INLINE  /*nothing*/
#endif

#endif

#ifndef FRED_HPP
#define FRED_HPP

//#include "inline.hpp"

class Fred {
public:
  void f() throw();   // No code in the class body
  void g() throw();
};

#ifdef USE_INLINE   // #ifdef means "if defined"
  //#include "Fred.inl"
#endif

#endif

#include <iostream>
using namespace std;

INLINE void Fred::f() throw()  // Uses INLINE, not inline
{ cout << "Fred::f() is optionally inlined\n"; }

//#include "Fred.hpp"
using namespace std;

#ifndef USE_INLINE   // #ifndef means "if not defined"
  //#include "Fred.inl"
#endif

void Fred::g() throw()
{ cout << "Fred::g() is never inlined\n"; }

//#include "Fred.hpp"

int main()
{
  Fred x;
  x.f();
  x.g();
}
