// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

int readFromDatabase() throw()
{ return 42; }  // Pretend this reads from the database

class Fred {
public:
  int get() const throw();
private:
  mutable int cache_;
  mutable bool cacheOk_;
};

int Fred::get() const throw()
{
  if (! cacheOk_) {
    cache_ = readFromDatabase();
    cacheOk_ = true;
  }
  return cache_;
}

int main()
{
  Fred f;
  int x = f.get();  // Access the database the first time it's called
  int y = f.get();  // Uses the cache; no database calls
  int z = f.get();  // Uses the cache; no database calls
}

class Fred2 {
public:
  int get() const throw();
private:
  int cache_;
  bool cacheOk_;
};

int Fred2::get() const throw()
{
  if (! cacheOk_) {
    Fred2* self = const_cast<Fred2*>(this);
    self->cache_ = readFromDatabase();
    self->cacheOk_ = true;
  }
  return cache_;
}
