// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

namespace X {
  int i, j, k;
}

int k;

void f1() throw()
{
  int i = 0;
  using namespace X;  // make names from X accessible
  i++;                // local i
  j++;                // X::j
  k++;                // error: X::k or global k?
  ::k++;              // the global k
  X::k++;             // X's k
}

void f2() throw()
{
  int i = 0;
  using X::i;         // error: i declared twice in f2()
  using X::j;
  using X::k;         // hides global k

  i++;
  j++;                // X::j
  k++;                // X::k
}
