// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <cmath>
#include <iostream>
using namespace std;

class Complex {
public:
  Complex(float real=0.0) throw();
  static Complex rect(float real, float imag) throw();
  static Complex polar(float mag,  float ang) throw();
private:
  Complex(float real, float imag) throw();
  float real_, imag_;
};

inline Complex::Complex(float real) throw()
: real_(real)
, imag_(0)
{ }

inline Complex::Complex(float real, float imag) throw()
: real_(real)
, imag_(imag)
{ }

inline Complex Complex::rect(float real, float imag) throw()
{ return Complex(real, imag); }

inline Complex Complex::polar(float mag,  float ang) throw()
{ return Complex(mag*cos(ang), mag*sin(ang)); }

int main()
{
  Complex a;                        // real part=0, imag part=0
  Complex b = 3.14;                 // real part=3.14, imag part=0
  Complex c = Complex::rect(3,2);   // real part=3, imag part=2
  Complex d = Complex::polar(3,2);  // magnitude=3, angle=2 radians
}
