// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"
#include <iostream>
using namespace std;

class Wilma {
public:
  Wilma()  throw();
  void f() throw();
};

inline Wilma::Wilma()  throw() { cout << "Wilma ctor\n"; }
inline void Wilma::f() throw() { cout << "Wilma used\n"; }

class Fred {
public:
  Fred() throw();
  class Init;            // This declares nested class Fred::Init
protected:
  friend Init;           // So Fred::Init can access Fred::wilma_
  static Wilma* wilma_;  // This is now a static pointer
};

class Fred::Init {
public:
  Init()  throw() { if (count_++ == 0) wilma_ = new Wilma(); }
  ~Init() throw() { if (--count_ == 0) delete wilma_; }
private:
  static unsigned count_;
};

static Fred::Init fredInit;  // The key: a static Fred::Init object defined in the header file

inline Fred::Fred() throw()
{
  cout << "Fred ctor\n";
  wilma_->f();           // This is now safe
}

//#include "Fred.hpp"

Wilma* Fred::wilma_ = NULL;

unsigned Fred::Init::count_ = 0;
