// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Base {
public:
  Base() throw();
protected:
  void storeValue(int value) throw();
  int  retrieveValue() const throw();
private:
  int value_;
};

inline Base::Base()                     throw() : value_(37) { }
inline void Base::storeValue(int value) throw() { value_ = value; }
inline int  Base::retrieveValue() const throw() { return value_; }

class Derived : public Base {
public:
  void f(int i) throw();
};

void Derived::f(int i) throw() { storeValue(i); }

int main()
{
  Derived d;
  d.f(42);
}
