// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class X {
public:
  void f() throw();
  void g() throw();
private:
  int a_;
  float b_;
};

class Y1 {
public:
  void f() throw();
protected:
  X x_;             // Composition: Y1 is not a kind-of X
};

void Y1::f() throw()
{ x_.f(); }         // Y1 calls member functions in X ("reuse")

class Y2 : private X {  // Private inheritance: Y2 is not a kind-of X
public:
  using X::f;  // Same semantics as above: calls to Y2::f() end up in X::f()
};

class Y3 : protected X {  // Protected inheritance: Y3 is not a kind-of X
public:
  using X::f;  // Same semantics as above: calls to Y3::f() end up in X::f()
};
