// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Fred {
public:
  Fred(int i=3, int j=5) throw();  // Default constructor: can be called with no args
  friend bool operator<(const Fred&, const Fred&);
  friend bool operator==(const Fred&, const Fred&);
  // ...
};

void sample() throw()
{
  Fred x;       // Calls the default constructor
  Fred y(3,5);  // Same effect as with object x
  // ...
}

#include <new>
#include <vector>
using namespace std;

void sample2() throw(bad_alloc)
{
  Fred a[10];                    // arrays always use the contained object's default ctor
  vector<Fred> b(10);            // vector can also use the contained object's default ctor
  vector<Fred> c(10, Fred(7,9)); // vector doesn't have to use the default ctor
}

void sample3() throw()
{
  Fred x;    // Creates an object
  Fred y();  // Declares a function; does not create a Fred object
  // ...
}
