// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class MemberObject {
public:
  MemberObject()     throw();
  void doSomething() throw();
};

MemberObject::MemberObject()     throw() { cout << "MemberObject ctor\n"; }
void MemberObject::doSomething() throw() { cout << "MemberObject used\n"; }

class Base {
public:
  Base()           throw();
  virtual void f() throw();
};

Base::Base()   throw() { cout << "Base ctor\n"; f(); }
void Base::f() throw() { cout << "Base::f()\n"; }

class Derived : public Base {
public:
  Derived()        throw();
  virtual void f() throw();
protected:
  MemberObject m_;
};

Derived::Derived() throw() : Base(), m_() { cout << "Derived ctor\n"; }
void Derived::f()  throw() { cout << "Derived::f()\n"; m_.doSomething(); }

int main()
{
  Derived d;
  cout << "====\n";
  d.f();
}
