// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  Base() throw();
  virtual void f() throw();
  virtual ~Base() throw();
};

Base::Base() throw()
{
  cout << " Base::Base() calling f()\n";
  f();   // For clarity, this should be written Base::f();
}

void Base::f() throw()
{ cout << "  Base::f()\n"; }

Base::~Base()
{ }

class Derived : public Base {
public:
  Derived() throw();
  virtual void f() throw();
};

Derived::Derived() throw()
: Base()
{
  cout << " Derived::Derived() calling f()\n";
  f();   // For clarity, this should be written Derived::f();
}

void Derived::f() throw()
{ cout << "  Derived::f()\n"; }

int main()
{
  cout << "Creating a Derived:\n";
  Derived d;
}
