// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  virtual void f() throw();
  virtual void g() throw();
  virtual ~Base()  throw();
};

void Base::f() throw() { cout << "Base::f()\n"; }
void Base::g() throw() { cout << "Base::g()\n"; }
Base::~Base()  throw() { }

class Derived : public Base {
public:
  virtual void f() throw();
};

void Derived::f() throw() { cout << "Derived::f()\n";  }

int main()
{
  Base b;  // ok: Base is not an ABC
  b.f();
  b.g();

  Derived d;
  d.f();
  d.g();
}
