// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <string>
using namespace std;

class Person {
public:
  Person(const string& name, const string& suffix) throw(bad_alloc);
  // ...
private:
  string name_;
};

#if 1

Person::Person(const string& name, const string& suffix) throw(bad_alloc)
: name_(name + suffix)  // Good: use initialization rather than assignment
{ }

#else

Person::Person(const string& name, const string& suffix) throw(bad_alloc)
{ name_ = name + suffix; }  // Inefficient: assignment used rather than initialization

#endif
