// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <string>
using namespace std;

class Noisy {
public:
  Noisy(const string& msg) throw();
 ~Noisy() throw();
protected:
  string msg_;
};

Noisy::Noisy(const string& msg) throw()
: msg_(msg)
{ cout << "construct " << msg_ << "\n"; }

Noisy::~Noisy() throw()
{ cout << "destruct "  << msg_ << "\n"; }

class Fred : public Noisy {
public:
  Fred() throw();
protected:
  Noisy a_;
  Noisy b_;
};

Fred::Fred() throw()
: b_("b_")
, a_("a_")
, Noisy("base")
{ }

int main()
{ Fred x; }
