// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <cstring>
using namespace std;

class MyString {
public:
  MyString()                              throw(bad_alloc);
 ~MyString()                              throw();
  MyString(const MyString& s)             throw(bad_alloc);  // copy constructor
  MyString& operator= (const MyString& s) throw(bad_alloc);  // assignment
protected:
  unsigned len_;
  char*    data_;
};

MyString::MyString() throw(bad_alloc)
: len_(0)
, data_(new char[1])
{ data_[0] = '\0'; }

MyString::~MyString() throw()
{ delete[] data_; }

MyString::MyString(const MyString& s) throw(bad_alloc)
: len_ ( s.len_             )
, data_( new char[s.len_+1] )       // Not new char[len_+1]
{ memcpy(data_, s.data_, len_+1); }

int main()
{
  MyString a;      // default ctor; zero length String ("")
  MyString b = a;  // copy constructor
}
