// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <cstring>
using namespace std;

class MyString {
public:
  MyString(const char* s)               throw(bad_alloc); // promote const char*
  MyString(const MyString& s)           throw(bad_alloc); // copy constructor
  MyString& operator= (const MyString&) throw(bad_alloc); // assignment
 ~MyString()                            throw();
protected:
  unsigned len_;    // ORDER DEPENDENCY
  char*    data_;   // ORDER DEPENDENCY
};

MyString::MyString(const char* s) throw(bad_alloc)
: len_ ( strlen(s)        )
, data_( new char[len_+1] )
{ memcpy(data_, s, len_+1); }

MyString::~MyString() throw()
{ delete[] data_; }

int main()
{ MyString s = "xyzzy"; }
