// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <cstdlib>
#include <stdexcept>
using namespace std;

class MyString {
public:
  MyString(const char* s) throw(bad_alloc, runtime_error);
  MyString(const MyString& s) throw(bad_alloc);
  MyString& operator= (const MyString& s) throw(bad_alloc);
 ~MyString() throw();
protected:
  unsigned len_;
  char*    data_;
};

MyString::MyString(const char* s) throw(bad_alloc, runtime_error)
// no initialization list due to argument screening
{
  if (s == NULL)
    throw runtime_error("NULL pointer in MyString ctor");
  len_ = strlen(s);
  data_ = new char[len_+1];
  memcpy(data_, s, len_+1);
}

MyString::~MyString() throw()
{ delete[] data_; }

int main()
{ MyString s = "xyzzy"; }
