// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <stdexcept>
using namespace std;

class Number {
public:
  friend Number add(Number a, Number b) throw(range_error);
  friend Number mul(Number a, Number b) throw(range_error);
};

Number sample(Number a, Number b, Number c) throw(range_error)
{ return add(add(mul(a,b), mul(b,c)), mul(c,a)); }

inline Number operator+ (Number a, Number b) throw(range_error)
{ return add(a, b); }

inline Number operator* (Number a, Number b) throw(range_error)
{ return mul(a, b); }

Number sample2(Number a, Number b, Number c) throw(range_error)
{ return a*b + b*c + c*a; }
