// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fred {
public:
  Fred& operator++ ()   throw();
  Fred operator++ (int) throw();
};

Fred& Fred::operator++ () throw()
{
  cout << "do the increment here\n";
  return *this; // The prefix version returns the new value of *this
}

Fred Fred::operator++ (int) throw()
{
  Fred old = *this;
  ++(*this);    // The postfix version calls the prefix version
  return old;   // The postfix version returns the old value of *this
}

int main()
{
  Fred i;
  ++i;          // Call the prefix version
  i++;          // Call the postfix version
}
