// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Position { };  // The position of the Shape

class Shape {
public:
  // ...
protected:
  void operator= (const Shape& s) throw();
  Position p_;
};

inline void Shape::operator= (const Shape& s) throw()
{ p_ = s.p_; }

class Square : public Shape { /*...*/ };
class Circle : public Shape { /*...*/ };

void sample(Shape& a, Shape& b)
{ a = b; }  // Generates compilation error since Shape::operator=() is protected:

int main()
{
  Square a;
  Circle b;
  sample(a, b);
}

