// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <stdexcept>
using namespace std;

class X {
public:
  X() throw();
 ~X() throw();
};

X::X()  throw() { cout << "X ctor\n"; }
X::~X() throw() { cout << "X dtor\n"; }

class Y {
public:
  Y() throw(runtime_error);
};

Y::Y() throw(runtime_error)
{
  cout << "Y ctor throwing\n";
  throw runtime_error("thrown from Y ctor");
}

class A {
public:
  A() throw(int);
 ~A() throw();
protected:
  X x_;
  Y y_;
};

A::A() throw(int)
: x_()
, y_()  // The exception gets throw from here
{ cout << "A ctor\n"; }

A::~A() throw()
{ cout << "A dtor\n"; }

int main()
{
  try {
    A a;
    cout << "never gets here\n";
  }
  catch (exception& e) {
    cout << "main caught: " << e.what() << endl;
  }
}
