// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <string>
#include <map>
#include <iostream>
using namespace std;

typedef  map<string,int>  AgeMap;  // A typedef can make the rest easier to read

int main()
{
  AgeMap age;

  // The subscript operator is used to access an element in the map:
  age["Fred"] = 42;
  age["Barney"] = 38;
  int n = age["Fred"];
  int numElements = age.size();

  // Removing an element from the map:
  age.erase("Barney");

  // Iterators are used to loop through all the elements within the map:
  for (AgeMap::iterator p = age.begin(); p != age.end(); ++p)
    cout << "age of " << p->first << " is " << p->second << "\n";

  // Iterators can be used to check if an entry is in the map:
  AgeMap::const_iterator q = age.find("Fred");
  if (q == age.end())
    cout << "Fred isn't in the map\n";
  else
    cout << "Fred is in the map; his age is " << q->second << "\n";
}

