// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Member {
public:
  ~Member() throw();
};

Member::~Member() throw()
{ cout << "destructing a Member object\n"; }

class Fred {
public:
  // Fred doesn't have an explicit destructor
protected:
  Member member_;
};

int main()
{
  {
    Fred x;
    cout << "before destructing a Fred\n";
  }   // Compiler synthesized destructor Fred::~Fred() called here
  cout << "after destructing a Fred\n";
}
