// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Number {
public:
  Number() throw();
 ~Number() throw();
  Number(const Number& n) throw();
  Number& operator= (const Number& n) throw();
  Number& operator++ () throw();
  Number  operator++ (int) throw();
};

Number::Number() throw()
  { }
Number::~Number() throw()
  { cout << "dtor "; }
Number::Number(const Number& n) throw()
  { cout << "copy "; }
Number& Number::operator= (const Number& n) throw()
  { cout << "assign "; return *this; }
Number& Number::operator++ () throw()
  { cout << "increment "; return *this; }

Number Number::operator++ (int) throw()
{
  Number old = *this;
  ++(*this);
  return old;
}

int main()
{
  Number n;
  cout << "++n: ";  ++n;  cout << '\n';
  cout << "n++: ";  n++;  cout << '\n';
}
