// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Shape {
public:
  virtual void draw() throw() = 0;
  virtual void hide() throw() = 0;
  virtual ~Shape() throw();
};

Shape::~Shape() throw()
{ }

class Circle : public Shape {
public:
  /*final*/ void draw() throw();
  virtual void hide() throw();
};

void Circle::draw() throw()
  { }
void Circle::hide() throw()
  { }

void sample(Circle& c) throw()
{
  c.Circle::draw();  // GOOD: Circle::draw() is a final
  c.Circle::hide();  // EVIL: subverts dynamic binding
  c.hide();          // GOOD: always calls the right hide() implementation
}

class FancyCircle : public Circle {
public:
  virtual void hide() throw();
};

void FancyCircle::hide() throw()
{ }

int main()
{
  FancyCircle x;
  sample(x);
}
