// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class B {
public:
  virtual void f() throw() = 0;
  virtual void g() throw() = 0;
  virtual void h() throw() = 0;
  virtual ~B();
};

B::~B()
  { }

class D : public B {
public:
  virtual void f() throw();
  virtual void g() throw();
  /*final*/ void h() throw();
};

void D::f() throw()
{
  g();     // GOOD: non-final member function called without full qualification
  D::h();  // GOOD: final member function called with full qualification
  D::g();  // EVIL: do not call non-final member function with full qualification!
}
void D::g()
  { }
void D::h()
  { }

class D2 : public D {
public:
  virtual void g() throw();
};

void D2::g()
  { }

int main()
{
  D2 x;
  x.f();
}
