// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "wtypes.h"
#include <initguid.h>

// {FC3B3F61-BCEC-11D1-91FE-E1CBED988F66}
DEFINE_GUID(IID_IStack,
    0xFC3B3F61, 0xBCEC, 0x11D1, 0x91, 0xFE,
    0xE1, 0xCB, 0xED, 0x98, 0x8F, 0x66);
// {FC3B3F62-BCEC-11D1-91FE-E1CBED988F66}
DEFINE_GUID(CLSID_CoStack,
    0xFC3B3F62, 0xBCEC, 0x11D1, 0x91, 0xFE,
    0xE1, 0xCB, 0xED, 0x98, 0x8F, 0x66);

class IStack : public IUnknown {
public:
    STDMETHOD(Push) (long  value);
    STDMETHOD(Pop)  (long* value);
    STDMETHOD(Empty)(long* flag);
};

void useStack()
{
    IUnknown* unknownPtr = NULL;
    HRESULT hr = CoCreateInstance(CLSID_CoStack,     //LINE #1
        NULL, CLSCTX_ALL, IID_IUnknown, (void**)&unknownPtr);

    if (SUCCEEDED(hr)) {
        IStack* stackPtr = NULL;
        hr = unknownPtr->QueryInterface(IID_IStack,  //LINE #2
                                   (void**)&stackPtr);

        if (SUCCEEDED(hr)) {
            hr = stackPtr->Push(10);      //LINE #3
            long val;
            hr = stackPtr->Pop(&val);     //LINE #4
            stackPtr->Release();          //LINE #5
        }
        unknownPtr->Release();            //LINE #6
    }
}

int main()
{
    HRESULT hr = CoInitialize(NULL);   //LINE #7
    if (SUCCEEDED(hr)) {
        useStack();
    }
    CoUninitialize();                  //LINE #8
    return 0;
}
