// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <signal.h>
using namespace std;

class Fred {
public:
  void f(int n) throw();
  static void staticMethod(int n) throw();
  static void registerHandlerObject(Fred* p) throw();
private:
  static Fred* signalHandlerObject_;     //the handler object
};

void Fred::f(int n)
  { cout << "Fred::f()\n"; }
void Fred::registerHandlerObject(Fred* p)
  { signalHandlerObject_ = p; }
void Fred::staticMethod(int n)
  {
    Fred* p = Fred::signalHandlerObject_;
    p->f(n);
  }
Fred* Fred::signalHandlerObject_ = NULL;

int main()
{
  //signal(SIGINT, Fred::f);            // ERROR: Cannot do this
  Fred x;
  Fred::registerHandlerObject(&x);
  signal(SIGINT, Fred::staticMethod);   // Good
}
