// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fred {
public:
  void f(int i);
  void g(int i);
  void h(int i);
};

void Fred::f(int i)
  { cout << "Fred::f(int); i=" << i << '\n'; }
void Fred::g(int i)
  { cout << "Fred::g(int); i=" << i << '\n'; }
void Fred::h(int i)
  { cout << "Fred::h(int); i=" << i << '\n'; }

typedef void (Fred::*FredMemberPtr) (int);

FredMemberPtr array[3] = { &Fred::f, &Fred::g, &Fred::h };

int main()
{
  Fred x;
  for (int i = 0; i < 3; ++i) {
    FredMemberPtr p = array[i];
    (x.*p)(42 + i);
  }
}
